//
//  ViewController.swift
//  NotificationDemo
//
//  Created by 5km on 2019/3/16.
//  Copyright © 2019 5km. All rights reserved.
//

import Cocoa
import UserNotifications

class ViewController: NSViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
    }

    override var representedObject: Any? {
        didSet {
        // Update the view, if already loaded.
        }
    }
    
    @IBAction func notificationAction(_ sender: Any) {
        let content = UNMutableNotificationContent()
        content.title = "新的方式"
        content.body = "我是一个新的方式"
        
        content.userInfo = ["method": "new"]
        
        content.sound = UNNotificationSound.default
        content.categoryIdentifier = "NOTIFICATION_DEMO"
        
        let acceptAction = UNNotificationAction(identifier: "SHOW_ACTION", title: "显示", options: .init(rawValue: 0))
        let declineAction = UNNotificationAction(identifier: "CLOSE_ACTION", title: "关闭", options: .init(rawValue: 0))
        let testCategory = UNNotificationCategory(identifier: "NOTIFICATION_DEMO",
                                                  actions: [acceptAction, declineAction],
                                                  intentIdentifiers: [],
                                                  hiddenPreviewsBodyPlaceholder: "",
                                                  options: .customDismissAction)
        
        let request = UNNotificationRequest(identifier: "NOTIFICATION_DEMO_REQUEST",
                                            content: content,
                                            trigger: nil)
        
        // Schedule the request with the system.
        let notificationCenter = UNUserNotificationCenter.current()
        notificationCenter.delegate = self
        notificationCenter.setNotificationCategories([testCategory])
        notificationCenter.add(request) { (error) in
            if error != nil {
                // Handle any errors.
            }
        }
    }
    
}

extension ViewController: UNUserNotificationCenterDelegate {
    
    // 用户点击弹窗后的回调
    func userNotificationCenter(_ center: UNUserNotificationCenter, didReceive response: UNNotificationResponse, withCompletionHandler completionHandler: @escaping () -> Void) {
        let userInfo = response.notification.request.content.userInfo
        switch response.actionIdentifier {
        case "SHOW_ACTION":
            print(userInfo)
        case "CLOSE_ACTION":
            print("Nothing to do")
        default:
            break
        }
        completionHandler()
    }
    
    // 配置通知发起时的行为 alert -> 显示弹窗, sound -> 播放提示音
    func userNotificationCenter(_ center: UNUserNotificationCenter, willPresent notification: UNNotification, withCompletionHandler completionHandler: @escaping (UNNotificationPresentationOptions) -> Void) {
        completionHandler([.alert, .sound])
    }
}

